<%
response.buffer = true
%>
<!-- #include file="freeaspupload.inc" -->
<%
Function ExtractDirName(strFilename)
    ' Removes the directory from a string that contains path and filename
    If Len(strFilename) > 1 Then
		For I = 1 to 2
			Dim X 
			For X = Len(strFilename) To 1  Step -1 
				If Mid(strFilename, X, 1) = "/" Then Exit  For 
			Next 
			If Len(strFilename) > 1 Then
				strFilename = Left(strFilename, X - 1)
			Else
				strFilename = "/"
				X = 2
			End If
		Next 
	   	ExtractDirName = Left(strFilename, X - 1)
    End If
End Function

Function ShowImageForType(strName)
' For the 'explorer': shows file-icons
	Dim strTemp
	strTemp = strName
	If strTemp <> "dir" Then
		strTemp = LCase(Right(strTemp, Len(strTemp) - InStrRev(strTemp, ".", -1, 1)))
	End If
	Select Case strTemp
		Case "asp"
			strTemp = "asp"
		Case "dir"
			strTemp = "dir"
		Case "htm", "html"
			strTemp = "htm"
		Case "gif", "jpg"
			strTemp = "img"
		Case "txt"
			strTemp = "txt"
		Case Else
			strTemp = "misc"
	End Select
	strTemp = "<IMG SRC=""images/dir_" & strTemp & ".gif"" WIDTH=16 HEIGHT=16 BORDER=0>"
	ShowImageForType = strTemp
End Function

function SaveFiles(PathToSaveTo)
' Saves potentially uploaded files
    Dim Upload, fileName, fileSize, ks, i, fileKey
    Set Upload = New FreeASPUpload
    Upload.Save(PathToSaveTo)
    SaveFiles = ""
    ks = Upload.Errors.keys
	' if errors ar returned by the component
    if (UBound(ks) <> -1) then
        SaveFiles = ""
        for each fileKey in Upload.Errors.keys
            SaveFiles = SaveFiles & Upload.Errors(fileKey)&" " 
        next
    else
        SaveFiles = "no errors"
    end if
end function
%>

<%' Now to the Runtime code:
Dim strPath   'Path of directory to show
Dim objFSO    'FileSystemObject variable
Dim objFolder 'Folder variable
Dim objItem   'Variable used to loop through the contents of the folder
varDirPath = Request.QueryString("dirpath")
BasePath = " "   

If Len(varDirPath) > 1 Then
   strPath = varDirPath & "/"
Else
   strPath = "/" 
   'BasePath = strPath 
End If
Set objFSO = Server.CreateObject("Scripting.FileSystemObject")
Set objFolder = objFSO.GetFolder(Server.MapPath(BasePath & strPath))
%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>{$lang_insert_image_title}</title>
	<script language="javascript" type="text/javascript" src="../../tiny_mce_popup.js"></script>
	<script language="javascript" type="text/javascript" src="../../utils/mctabs.js"></script>
	<script language="javascript" type="text/javascript" src="../../utils/form_utils.js"></script>
	<script language="javascript" type="text/javascript" src="jscripts/functions.js"></script>

<script type="text/javascript">
<!--
var maxImgWidth = 222;
var maxImgHeight = 260;

function PreviewFile()
{
 // resizes the preview-image to fit the window
  var Img = new Image();
  Img.src = document.images['ImgVar'].src
  var x=parseInt(Img.width);
  var y=parseInt(Img.height);
  if (x>maxImgWidth) {
    y*=maxImgWidth/x;
    x=maxImgWidth;
  }
  if (y>maxImgHeight) {
    x*=maxImgHeight/y;
    y=maxImgHeight;
  }
 if ((x!=0)||(y!=0))
	 {
	  document.images['ImgVar'].width=x;
	  document.images['ImgVar'].height=y;
	 }
}

function FileChosen(FileName)
{
document.forms[0].elements['filename'].value='<%= strPath %>' + FileName;
showPreviewImage(document.forms[0].elements['filename'].value);
 // We need to wait until the image is loaded, onload of the image 'PreviewFile' is triggered
}
//-->
</script>	
 <link href="css/aspimage.css" rel="stylesheet" type="text/css" />
 <base target="_self" />
</head>
<body id="aspimage" onload="tinyMCEPopup.executeOnLoad('init();');" style="display: none">
<script type="text/javascript">
<%
' This piece of code displays any errors from the upload component in a JS popup.
if Request.ServerVariables("REQUEST_METHOD") = "POST" then
	If varDirPath <> "" Then
		response.write("alert(""Upload failed: " & SaveFiles(Server.MapPath(varDirPath)) & """);")
	Else
		varDirPath = "/"
		response.write("alert(""Upload failed: " & SaveFiles(Server.MapPath(varDirPath)) & """);")
	End If
end if
%>
</script>
<div class="tabs">
	<ul>
		<li id="general_tab" class="current"><span><a href="javascript:mcTabs.displayTab('general_tab','general_panel');" onmousedown="return false;">{$lang_aspimage_tab_general}</a></span></li>
		<li id="appearance_tab"><span><a href="javascript:mcTabs.displayTab('appearance_tab','appearance_panel');" onmousedown="return false;">{$lang_aspimage_tab_appearance}</a></span></li>
	</ul>
</div>
<form name="filebrowser" method="POST" enctype="multipart/form-data" action="" onsubmit="return finished()">
<div class="panel_wrapper">
	<div id="general_panel" class="panel current">
		<div class="leftColumn">
			<h1>Directory browser</h1>
		<%strNPath = strPath%>
		<% Response.flush() %>
			<div class="explorer">
					<table>
						<tr>
							<th>Name</th>
							<th>Size</th>
							<!--<th>Type</th>-->
							<th>Modified</th>
						</tr>
						<tr>
							<td>&nbsp;<a href="?dirpath=<%=ExtractDirName(strNPath)%>".."><img src="images/dir_pdir.gif" width="16" height="16" border="0" alt="parent directory">..</a></td>
							<td>&nbsp;</td>
							<!--<td>&nbsp;</td>-->
							<td>&nbsp;</td>
						</tr>
		<%			Dim RowCount
						RowCount = 0
					For Each objItem In objFolder.SubFolders
						If InStr(1, objItem, "_vti", 1) = 0 Then%>
						<tr <% If RowCount MOD 2 = 0 Then%>class="darkRow"<% End If %>>
							<td><%= ShowImageForType("dir") %>&nbsp;<a href="?dirpath=<%= strPath & objItem.Name %>"><%= objItem.Name %></a></td>
							<td><%'= objItem.Size %></td>
							<!--<td><%'= objItem.Type %></td>-->
							<td><%= objItem.DateCreated %></td>
						</tr>
		<%				RowCount = RowCount + 1
						End If
					Next %>
		
		<%			For Each objItem In objFolder.Files	%>
						<tr <% If RowCount MOD 2 = 0 Then%>class="darkRow"<% End If %>>
							<td nowrap><%= ShowImageForType(objItem.Name) %>&nbsp;<a href="Javascript:FileChosen('<%= objItem.Name %>')"><%= objItem.Name %></a></td>
							<td><%= objItem.Size %></td>
							<!--<td><%= objItem.Type %></td>-->
							<td nowrap><%= objItem.DateCreated %></td>
						</tr>
		<%				RowCount = RowCount + 1
					Next %>
					</table>
			</div>
		</div>
		<%
		Set objItem = Nothing
		Set objFolder = Nothing
		Set objFSO = Nothing
		%>
		<div class="rightColumn">
			<h1>Image Preview</h1>
			<div id="prev">
		
			</div>
		</div>
		
		<br clear="all"/>
		<table width="100%" border="0">
			<tr>
				<td width="80"><label for="upload">upload:</label></td>
				<td width="274"><input type="file" name="upload" id="upload" size="32"><input type="hidden" name="chosendir" value="<%= strPath %>"></td>
				<td width="*"><input id="insert" type="submit" name="Submit" value="Upload"></td>
			</tr>
		</table>
			</div>

			<div id="appearance_panel" class="panel">
				<fieldset>
					<legend>{$lang_aspimage_tab_appearance}</legend>
					<table border="0" cellpadding="4" cellspacing="0">
						<tr>
							<td class="column1"><label id="srclabel" for="filename">{$lang_insert_image_src}</label></td>
							<td colspan="2"><table border="0" cellspacing="0" cellpadding="0">
								<tr> 
								  <td><input type="text" name="filename" id="filename" class="largetextfield" onchange="showPreviewImage(this.value);"></td> 
								  <td id="srcbrowsercontainer">&nbsp;</td>
								</tr>
							  </table></td>
						</tr>					
						<tr> 
							<td class="column1"><label id="altlabel" for="alt">{$lang_insert_image_alt}</label></td> 
							<td colspan="2"><input id="alt" name="alt" type="text" value="" /></td> 
						</tr> 
						<tr> 
							<td class="column1"><label id="titlelabel" for="title">{$lang_aspimage_title}</label></td> 
							<td colspan="2"><input id="title" name="title" type="text" value="" /></td> 
						</tr>					
						<tr> 
							<td class="column1"><label id="alignlabel" for="align">{$lang_insert_image_align}</label></td> 
							<td><select id="align" name="align" onchange="changeAppearance();"> 
									<option value="">{$lang_insert_image_align_default}</option> 
									<option value="baseline">{$lang_insert_image_align_baseline}</option> 
									<option value="top">{$lang_insert_image_align_top}</option> 
									<option value="middle">{$lang_insert_image_align_middle}</option> 
									<option value="bottom">{$lang_insert_image_align_bottom}</option> 
									<option value="texttop">{$lang_insert_image_align_texttop}</option> 
									<option value="absmiddle">{$lang_insert_image_align_absmiddle}</option> 
									<option value="absbottom">{$lang_insert_image_align_absbottom}</option> 
									<option value="left">{$lang_insert_image_align_left}</option> 
									<option value="right">{$lang_insert_image_align_right}</option> 
								</select> 
							</td>
							<td rowspan="6" valign="top">
								<div class="alignPreview">
									<img id="alignSampleImg" src="images/sample.gif" alt="{$lang_aspimage_example_img}" />
									Lorem ipsum, Dolor sit amet, consectetuer adipiscing loreum ipsum edipiscing elit, sed diam
									nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.Loreum ipsum
									edipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam
									erat volutpat.
								</div>
							</td>
						</tr>

						<tr>
							<td class="column1"><label id="widthlabel" for="width">{$lang_insert_image_dimensions}</label></td>
							<td nowrap="nowrap">
								<input name="width" type="text" id="width" value="" size="5" maxlength="5" onchange="changeHeight();" /> x 
								<input name="height" type="text" id="height" value="" size="5" maxlength="5" onchange="changeWidth();" /> px
							</td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td><table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><input id="constrain" type="checkbox" name="constrain" class="checkbox" /></td>
										<td><label id="constrainlabel" for="constrain">{$lang_aspimage_constrain_proportions}</label></td>
									</tr>
								</table></td>
						</tr>

						<tr>
							<td class="column1"><label id="vspacelabel" for="vspace">{$lang_insert_image_vspace}</label></td> 
							<td><input name="vspace" type="text" id="vspace" value="" size="3" maxlength="3" onchange="changeAppearance();updateStyle();" />
							</td>
						</tr>

						<tr> 
							<td class="column1"><label id="hspacelabel" for="hspace">{$lang_insert_image_hspace}</label></td> 
							<td><input name="hspace" type="text" id="hspace" value="" size="3" maxlength="3" onchange="changeAppearance();updateStyle();" /></td> 
						</tr>

						<tr>
							<td class="column1"><label id="borderlabel" for="border">{$lang_insert_image_border}</label></td> 
							<td><input id="border" name="border" type="text" value="" size="3" maxlength="3" onchange="changeAppearance();updateStyle();" /></td> 
						</tr>
						<tr>
							<td class="column1"><label id="stylelabel" for="style">{$lang_aspimage_style}</label></td> 
							<td colspan="2"><input id="style" name="style" type="text" value="" onchange="styleUpdated();" /></td> 
						</tr>
					</table>
				</fieldset>
			</div>
</div>
<div class="mceActionPanel">
	<div style="float: left">
		<input type="button" id="insert" name="insert" value="{$lang_insert}" onclick="insertAction();" />
	</div>

	<div style="float: right">
		<input type="button" id="cancel" name="cancel" value="{$lang_cancel}" onclick="cancelAction();" />
	</div>
</div>
</form>
<!-- 
    <form onsubmit="insertAction();return false;" action="#"> 
		<fieldset>
				<legend>{$lang_aspimage_general}</legend>

				<table class="properties">
					<tr>
						<td class="column1"><label id="srclabel" for="src">{$lang_insert_image_src}</label></td>
						<td colspan="2"><table border="0" cellspacing="0" cellpadding="0">
							<tr> 
							  <td><input name="src" type="text" id="src" value="" onchange="showPreviewImage(this.value);" /></td> 
							  <td id="srcbrowsercontainer">&nbsp;</td>
							</tr>
						  </table></td>
					</tr>
					<tr id="imagelistsrcrow">
						<td class="column1"><label for="imagelistsrc">{$lang_image_list}</label></td>
						<td colspan="2" id="imagelistsrccontainer">&nbsp;</td>
					</tr>
					<tr> 
						<td class="column1"><label id="altlabel" for="alt">{$lang_insert_image_alt}</label></td> 
						<td colspan="2"><input id="alt" name="alt" type="text" value="" /></td> 
					</tr> 
					<tr> 
						<td class="column1"><label id="titlelabel" for="title">{$lang_aspimage_title}</label></td> 
						<td colspan="2"><input id="title" name="title" type="text" value="" /></td> 
					</tr>
				</table>
		</fieldset>
		<div class="mceActionPanel">
			<div style="float: left">
				<input type="button" id="insert" name="insert" value="{$lang_insert}" onclick="insertAction();" />
			</div>

			<div style="float: right">
				<input type="button" id="cancel" name="cancel" value="{$lang_cancel}" onclick="cancelAction();" />
			</div>
		</div>
    </form>
	-->
</body> 
</html> 
