function isEmpty (s) {
	if ( s == "" || s == null ) {
		return true;
	}
	return false;
}

function isEmail(str) {
  // are regular expressions supported?
  var supported = 0;
  if (window.RegExp) {
    var tempStr = "a";
    var tempReg = new RegExp(tempStr);
    if (tempReg.test(tempStr)) supported = 1;
  }
  if (!supported) 
    return (str.indexOf(".") > 2) && (str.indexOf("@") > 0);
  var r1 = new RegExp("(@.*@)|(\\.\\.)|(@\\.)|(^\\.)");
  var r2 = new RegExp("^.+\\@(\\[?)[a-zA-Z0-9\\-\\.]+\\.([a-zA-Z]{2,3}|[0-9]{1,3})(\\]?)$");
  return (!r1.test(str) && r2.test(str));
}

// CheckIsDollar - Checks to see if the entered value is a number representing a monitry value.
function CheckIsDollar(e){
  var msg1 = "Please enter a currency value, dollar sign is not required.";
  var msg2 = "Not a valid number please re-enter";
  var newStr = "";
  var s = e.value;
  if ( s.charAt(0) == "$" ){
    for ( var i = 1; i < (s.length); i++){
      var c = s.charAt(i);
      newStr += c;
    }
  }
  else{
    newStr = s;
  }
  e.value = newStr;
  if( !IsNumber(newStr) ){
    alert(msg2);
    e.focus();
 	e.select();
    return false;
  }
  return true;
}

// IsNumber - Checks to see if the value passed is a number, that is not containing non-numeric
// characters.
function IsNumber(inputStr, integer) {
	var intcount=0;
	
  for ( var i = 0; i < inputStr.length; i++) {
     var oneChar = inputStr.charAt(i);
     
     if (oneChar == ".") {
     		if ( integer ) {
     			return false;
     		} else {
     			intcount++ ;
     			
     			if ( intcount > 1 ) {
     				return false;
     			}
     		}
     }
     else if ( (oneChar < "0" || oneChar > "9") ) {
        	return false;
     }
  }

  return true;
}

function IsValidDate(p)
{
  var sErrMsg = "Please Enter a Valid Date."
  with (p){
   // Declaring variables
    if (!isEmpty(value)){
      var MonthArr = new Array(12);
      var v_date = value;
      v_split = v_date.indexOf("/");
      v_split2 = v_date.indexOf("/", v_split + 1);
      var v_day = v_date.substring(0, v_date.indexOf("/"));
      var del1 = v_date.substring(v_split, v_split + 1);
      var v_month = v_date.substring(v_split + 1, v_split2);
      var del2 = v_date.substring(v_split2, v_split2 + 1);
      var v_year= v_date.substring(v_split2 + 1, v_date.length);

      // creating array of months 1 - 12
      // Also compensating for leap years
      MonthArr["1"] = 31
      MonthArr["01"] = 31
      if (((v_year % 4 == 0) && (v_year % 100 != 0)) || (v_year % 400 == 0)) {
         MonthArr["2"] = 29
         MonthArr["02"] = 29
      } else {
         MonthArr["2"] = 28
         MonthArr["02"] = 28
      }
      MonthArr["3"] = 31
      MonthArr["03"] = 31
      MonthArr["4"] = 30
      MonthArr["04"] = 30
      MonthArr["5"] = 31
      MonthArr["05"] = 31
      MonthArr["6"] = 30
      MonthArr["06"] = 30
      MonthArr["7"] = 31
      MonthArr["07"] = 31
      MonthArr["8"] = 31
      MonthArr["08"] = 31
      MonthArr["9"] = 30
      MonthArr["09"] = 30
      MonthArr["10"] = 31
      MonthArr["11"] = 30
      MonthArr["12"] = 31

      if (eval(value != '')) {
         if (v_day < 1 || v_day > MonthArr[v_month] || isNaN(v_day)) {
            alert(sErrMsg);
            focus();
            return false;
         } else {
         if (MonthArr[v_month] == null) {
            alert(sErrMsg);
            focus();
           return false;
         } else {
            if (isNaN(v_year) || v_year == "" || v_year.length != 4){
            alert(sErrMsg);
            focus();
            return false;
            }
         }
      }
   }
 }
}
   return true;
}

function formatNumber(expr, decplaces){
// this function formats the number to two decimal places
  var tempstr;
  tempstr =  "" + Math.round(eval(expr) * Math.pow(10,decplaces));
  while (tempstr.length <= decplaces){
    tempstr = "0" + tempstr
  }
    var decpoint = tempstr.length - decplaces;
    return tempstr.substring(0, decpoint) + '.' + tempstr.substring(decpoint, tempstr.length);
}